#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace RepeaterUserControlSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
			/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
					this.gridRepeaterUserControl1.Grid.Dispose();
					this.gridRepeaterUserControl1.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridRepeaterUserControl1 = new GridRepeaterControl.GridRepeaterUserControl();
			this.SuspendLayout();
			// 
			// gridRepeaterUserControl1
			// 
			this.gridRepeaterUserControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridRepeaterUserControl1.BackColor = System.Drawing.SystemColors.ControlDarkDark;
			this.gridRepeaterUserControl1.DockPadding.All = 2;
			this.gridRepeaterUserControl1.Location = new System.Drawing.Point(32, 24);
			this.gridRepeaterUserControl1.Name = "gridRepeaterUserControl1";
			this.gridRepeaterUserControl1.Size = new System.Drawing.Size(392, 320);
			this.gridRepeaterUserControl1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridRepeaterUserControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private GridRepeaterControl.GridRepeaterUserControl gridRepeaterUserControl1;

		private DataTable dt;
		private void Form1_Load(object sender, System.EventArgs e)
		{

			//create two instances of your user control that defines the control to be repeated.
			// SampleUserControl must derive from GridRepeaterControl.CellUserControl which
			// is derived from UserControl and ICellUserControl. The ICellUserControl support 
			// is what binds the grid cells to your UserControl.
			SampleUserControl.SampleUserControl activeControl = new SampleUserControl.SampleUserControl();
			SampleUserControl.SampleUserControl staticControl = new SampleUserControl.SampleUserControl();

			this.gridRepeaterUserControl1.AddUserControls(activeControl, staticControl, 3);
			
			//set the binding on the repeater control
			dt = GetTable();
			this.gridRepeaterUserControl1.SetDataBinding(dt);

			//display a second form showing the data in a grid (just as a check)
			//Form2 f = new Form2();
			//f.gridDataBoundGrid1.DataSource = dt;
			//f.gridDataBoundGrid1.CurrentCell.MoveTo(-1, -1);//no current cell
			//f.Show();
			
			//this.ActiveControl = gridRepeaterUserControl1.Grid;
			//gridRepeaterUserControl1.Grid.CurrentCell.MoveTo(1, 1);
			//gridRepeaterUserControl1.Grid.CurrentCell.BeginEdit();

			// Handle the SaveCellInfo and set e.Handled to true so that
			// values are not saved to GridData
			this.gridRepeaterUserControl1.Grid.SaveCellInfo += new GridSaveCellInfoEventHandler(Grid_SaveCellInfo);

		}

		#region Sample Data
		private DataTable GetTable()
		{
			DataTable dt = new DataTable("Table");
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("City"));
			dt.Columns.Add(new DataColumn("Zip"));

			for(int i = 0; i < 50; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = string.Format("name{0}", i);
				dr[1] = string.Format("city{0}", i);
				dr[2] = string.Format("zip{0}", i);
				dt.Rows.Add(dr);
			}
			return dt;
		}
		#endregion

		private void Grid_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			e.Handled = true;
		}
	}
}
